package authdiscord

import (
	"fmt"

	configserver "example.com/config/server"

	"github.com/ravener/discord-oauth2"
	"golang.org/x/oauth2"
)

type DiscordUser struct {
	Id                     string
	Username               string
	Avatar                 string
	Discriminator          string
	Public_Flags           float64
	Flags                  float64
	Banner                 string
	Accent_Color           float64
	Global_Name            string
	Avatar_Decoration_Data struct {
		Asset      string
		Sku_Id     string
		Expires_At string
	}
	Collectibles  string
	Banner_Color  string
	Clan          string
	Primary_Guild string
	Mfa_Eneabled  bool
	Locale        string
	Premium_Type  float64
}

func CreateDiscordOAuthConfig(config configserver.AppConfig) *oauth2.Config {
	protocolString := ""
	if config.API.Https {
		protocolString = "https://"
		config.API.Port = ""
	} else {
		protocolString = "http://"
		config.API.Port = fmt.Sprintf(":%s", config.API.Port)
	}
	redirectUrlString := fmt.Sprintf("%s%s%s/auth/callback", protocolString, config.API.Domain, config.API.Port)
	oauthconfig := &oauth2.Config{
		ClientID:     config.OAuth.ClientID,
		ClientSecret: config.OAuth.ClientSecret,
		RedirectURL:  redirectUrlString,
		Scopes:       []string{discord.ScopeIdentify},
		Endpoint:     discord.Endpoint,
	}
	return oauthconfig
}
